function psnr = psnrcalc(origFrame,recFrame)
  % This function takes in the original frame and the 
  % reconstructed frame and calculates the PSNR based 
  % on the distortion in the reconstructed frame.
  
  % If the frames are equal, the PSNR is infinite
  if origFrame == recFrame
    error('Images are identical: PSNR has infinite value')
  end  
  psnr=10*log10(255^2/(mean((origFrame(:)-recFrame(:)).^2)));  
end